=== debian/changelog ===
nextcloud-desktop (2.5.1-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Alexander GQ Gerasiov <gq@debian.org>  Sun, 03 Feb 2019 19:04:22 +0300

nextcloud-desktop (2.5.1-1) unstable; urgency=medium

  * Initial release (Closes: #847613)

 -- Sandro Knauß <hefee@debian.org>  Tue, 15 Jan 2019 22:32:03 +0100
