=== debian/changelog ===
nextcloud-desktop (2.5.1.1+rb2-1+eagle) unstable; urgency=medium

  * update

 -- ownCloud for Debian maintainers <pkg-owncloud-maintainers@lists.alioth.debian.org>  Thu, 28 Jan 2021 19:56:20 +0800

nextcloud-desktop (2.5.1-3+deb10u1) buster; urgency=medium

  * Make nextcloud-desktop-cmd depend on nextcloud-desktop-common.
  * Add QPainterPath header.

    Thanks to Calogero Lo Leggio (Closes: #932108)

 -- Sandro Knauß <hefee@debian.org>  Thu, 29 Aug 2019 18:57:38 +0200

nextcloud-desktop (2.5.1-3) unstable; urgency=medium

  * Fix "Subfolders of moved folders not synced" (Closes: #929079)
    Added 0005-Fixed-Issue-1000-Subfolders-of-moved-folders-not-syn.patch

 -- Sandro Knauß <hefee@debian.org>  Thu, 16 May 2019 16:14:50 +0200

nextcloud-desktop (2.5.1-2) unstable; urgency=medium

  [ Adrian Heine ]
  * Fix VCS urls

  [ Louis-Philippe Véronneau ]
  * Add man page (Closes: #921344)

 -- Sandro Knauß <hefee@debian.org>  Tue, 12 Feb 2019 23:54:02 +0100
