=== debian/rules ===
--- 
+++ 
@@ -27,6 +27,10 @@
 	dh_auto_build -- doc-html
 	dh_auto_build # unfortunatelly we don't get icons and translations otherwise.
 
+override_dh_auto_build-arch:
+	dh_auto_build -- doc-man
+	dh_auto_build --
+
 override_dh_missing:
 	dh_missing --list-missing
